# Author:   Humair Ahmed
# Version:  1.0
# Date:     10/20/2011
# Website:  http://www.HumairAhmed.com
# 
# Open source software being distributed under GPL license. For more information see here:
# http://www.gnu.org/copyleft/gpl.html. 
 



#!/usr/bin/perl -w

use strict;
use LWP::UserAgent;
use LWP::Simple;
use HTTP::Request::Common qw(GET); #export the GET method


#create a UserAgent object
my $browser = LWP::UserAgent->new();
my $url = "http://www.alexa.com/topsites";
my $siteUrl = "";
my $server = "";


#create the request object
my $request = GET($url);


#get the HTTP::Response object.
my $response = $browser->request($request); 

if ($response->is_success) 
{
	my $page = $response->content; #get webpage content

	#regex pattern will match the html span tag containing the website name
	my @topList = $page =~ /<span class="small topsites-label">.+<\/span>/g;
	my $topListString = join('', @topList); 
 
	#regex pattern will narrow the match further such as >facebook.com<
	my @topList2 = $topListString =~ />[\w\.-]+</g;
    
	my $site;
	my $counter = 1; #counter for website rank
    
	foreach(@topList2) #for each match
	{
		#chop off the '>' and '<' characters surrounding the website name
		chop $_;
		$_ = reverse $_;
		chop $_;
		$_ = reverse $_;
    
		#create the full url
		$siteUrl = "http://www." . $_; 

		#get some info from the header
		my ($content_type, $document_length, $modified_time, $expires, $server) 
			= head($siteUrl);
    		
		#if the server is not defined in the header, state server could not be 
		#identified
		if(!defined($server))
		{
			$server = "Could not be identifed";
		}
    	
		printf("%-3s %-20sServer: $server\n", "$counter:", $_);

		$counter++;    	
	}
} 
else 
{
	print $response->status_line . "\n";
}